//
//  ContentView.swift
//  BugNavigation
//
//  Created by Miguel de Icaza on 9/27/22.
//

import SwiftUI

class State: ObservableObject {
    @Published var count: Int = 0
}

var globalState = State()

struct HomeView: View {
    @ObservedObject var state: State = globalState
    
    var body: some View {
        Text ("The child has been pressed \(state.count)")
    }
}

import SwiftUI

struct NestedView: View {
    @ObservedObject var state: State = globalState
    var txt: String
    var body: some View {
        NavigationLink("Run me", destination: {
            Text ("\(txt)\nThanks for clicking")
                .onAppear {
                    Task {
                        //try? await Task.sleep(nanoseconds: 4_000_000_000)
                        DispatchQueue.main.async {
                            globalState.count += 1
                        }
                    }
                }
        })
    }
}
                       
struct DefaultHomeView: View {
    @ObservedObject var state: State = globalState

    var body: some View {
        if state.count > 0 {
            NavigationLink (
                destination: NestedView (txt: "Reuse"),
                label: {
                    Text ("Click again")
                } )
        } else {
            NavigationLink (
                destination: NestedView (txt: "First Use"),
                label: {
                    Text ("First Click")
                } )

        }
    }
}

struct ContentView: View {
    var body: some View {
        NavigationView {
            HomeView ()
            
            DefaultHomeView ()
        }
    }
}

struct ContentView_Previews: PreviewProvider {
    static var previews: some View {
        ContentView()
    }
}
